#!/bin/sh

major=195

for i in 0 1 2 3; do
	devfile="/dev/nvidia$i"
	rm -f $devfile
	if ! mknod $devfile c $major $i || ! chmod 0666 $devfile; then
		echo "Couldn't create device \"$devfile\"."
		exit 1
	fi
done

devfile=/dev/nvidiactl              
rm -f $devfile        
mknod $devfile c $major 255
chmod 0666 $devfile   

confmod=""

[ -f /etc/conf.modules ] && confmod="/etc/conf.modules"
[ -f /etc/modules.conf ] && confmod="/etc/modules.conf"

if [ -f $confmod ]; then
    conftmp=/tmp/conf$$
    sed '/^alias.*char-major-.*NVdriver/d' < $confmod > $conftmp
    echo "alias char-major-$major NVdriver" >> $conftmp        
    mv $conftmp $confmod
else
    # Deal with Slackware's setup
    if [ -f "/etc/rc.d/rc.modules" ]; then
        echo "/sbin/modprobe NVdriver.o" >> /etc/rc.d/rc.modules
    fi
fi

exit 0
